/************************************************************************************
 * Copyright (C) 2018 ALTIMA Company MACNICA, Inc. All Rights Reserved.\n
 *   This software is licensed "AS IS". 
 *   Please perform use of this software by a user's own responsibility and expense.
 *   It cannot guarantee in the maker side about the damage which occurred by the ab-
 *   ility not to use or use this software, and all damage that occurred secondarily.
 ***********************************************************************************/

#include <stdio.h>
#include "mem_util.h"

void sample_memset_incrementdata(unsigned int* start, unsigned int testdata, unsigned int size)
{
	unsigned int* endnext = (unsigned int*)((unsigned long long)start + size);

	while(start < endnext){
		*start = testdata++;
		start++;
		if(start < (unsigned int*)0x00000004)	break;
	}

	return;
}

void sample_memdmp_word(unsigned int target_phys_addr, const unsigned int* start, unsigned int size)
{
	unsigned int*	end;

	if((unsigned long long)start & 0xF){
		size += ((long long)start & 0xF);
		start = (unsigned int*)((unsigned long long)start & 0xFFFFFFF0);
	}
	if(size & 0xF){
		size += 16;
		size = size & 0xFFFFFFF0;
	}

	end = (unsigned int*)((unsigned long long)start + size);

	printf("ADDRESS:  +0       +4       +8       +C      \r\n");
	printf("---------+--------+--------+--------+--------\r\n");
	while(start < end){
		printf("%08X:", target_phys_addr);
		target_phys_addr += 0x10;
		for(int i=0; i<4; i++, start++){
			printf(" %08X", (int)*start);
		}
		printf("\r\n");
	}

	return;
}

void sample_memdmp_byte(unsigned int target_phys_addr, const unsigned char* start, unsigned int size)
{
	unsigned char*	end;
	unsigned char	ascii[17];

	if((unsigned long long)start & 0xF){
		size += ((unsigned long long)start & 0xF);
		start = (unsigned char*)((unsigned long long)start & 0xFFFFFFF0);
	}
	if(size & 0xF){
		size += 16;
		size = size & 0xFFFFFFF0;
	}

	end = (unsigned char*)((unsigned long long)start + size);

	printf("ADDRESS:  +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F | 1BYTE-CHAR     \r\n");
	printf("---------+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+---+----------------\r\n");
	while(start < end){
		printf("%08X:", target_phys_addr);
		target_phys_addr += 0x10;
		for(int i=0; i<16; i++, start++){
			printf(" %02X", (unsigned int)*start);
			if((*start <= 31) || ((127 <= *start)&&(*start <= 160)) || (224 <= *start)){
				ascii[i] = '.';
			} else if((*start  )){
				ascii[i] = *start;
			}
			target_phys_addr++;
		}
		ascii[16] = '\0';
		printf(" |%s\r\n", ascii);
	}

	return;
}
