/************************************************************************************
 * Copyright (C) 2018 ALTIMA Company MACNICA, Inc. All Rights Reserved.\n
 *   This software is licensed "AS IS". 
 *   Please perform use of this software by a user's own responsibility and expense.
 *   It cannot guarantee in the maker side about the damage which occurred by the ab-
 *   ility not to use or use this software, and all damage that occurred secondarily.
 ***********************************************************************************/

/* User Headers */
#include "magnes_ioctl.h" //from driver directory
#include "cmd.h"
#include "pci.h"

int root_pci_config_space_dump(void)
{
	int i;
	char *buf;
	unsigned int data;
	unsigned int root_pci_config_space[CONFIG_SPACE_SIZE/4] = {0};

	for(i=0; i < CONFIG_SPACE_SIZE/4; i++){
		config_read(1, i*4, &data);
		root_pci_config_space[i] = data;
	}

	buf = (char *)&root_pci_config_space[0x00];

	printf("\n");
	printf("Vender ID               = 0x%04x \n",          *(unsigned short *)(&buf[0x00]) );
	printf("Device ID               = 0x%04x \n",          *(unsigned short *)(&buf[0x02]) );
	printf("CMD                     = 0x%04x \n",          *(unsigned short *)(&buf[0x04]) );
	printf("STATUS                  = 0x%04x \n",          *(unsigned short *)(&buf[0x06]) );
	printf("Rev ID                  = 0x%02x \n",          *(unsigned char  *)(&buf[0x08]) );
	printf("Class Code              = 0x%02x%02x%02x \n",  *(unsigned char  *)(&buf[0x0b] ),
			*(unsigned char  *)(&buf[0x0a] ),
			*(unsigned char  *)(&buf[0x09] ));
	printf("Cache Line Size         = 0x%02x \n",          *(unsigned char  *)(&buf[0x0c]) );
	printf("Mst Latency Timer       = 0x%02x \n",          *(unsigned char  *)(&buf[0x0d]) );
	printf("Header Type             = 0x%02x \n",          *(unsigned char  *)(&buf[0x0e]) );
	printf("BIST                    = 0x%02x \n",          *(unsigned char  *)(&buf[0x0f]) );
	printf("BAR0                    = 0x%08x \n",          *(unsigned int   *)(&buf[0x10]) );
	printf("BAR1                    = 0x%08x \n",          *(unsigned int   *)(&buf[0x14]) );
	printf("Primary BUS NUM         = 0x%02x \n",          *(unsigned char  *)(&buf[0x18]) );
	printf("Secondary BUS NUM       = 0x%02x \n",          *(unsigned char  *)(&buf[0x19]) );
	printf("Subordinate BUS NUM     = 0x%02x \n",          *(unsigned char  *)(&buf[0x1a]) );
	printf("Secondary Latency Timer = 0x%02x \n",          *(unsigned char  *)(&buf[0x1b]) );
	printf("IO Base                 = 0x%02x \n",          *(unsigned char  *)(&buf[0x1c]) );
	printf("IO Limit                = 0x%02x \n",          *(unsigned char  *)(&buf[0x1d]) );
	printf("Secondary Status        = 0x%04x \n",          *(unsigned short *)(&buf[0x1e]) );
	printf("Mem Base                = 0x%04x \n",          *(unsigned short *)(&buf[0x20]) );
	printf("Mem Limit               = 0x%04x \n",          *(unsigned short *)(&buf[0x22]) );
	printf("Prefetchable Mem Base   = 0x%04x \n",          *(unsigned short *)(&buf[0x24]) );
	printf("Prefetchable Mem Limit  = 0x%04x \n",          *(unsigned short *)(&buf[0x26]) );
	printf("Prefetchable Base       = 0x%08x \n",          *(unsigned int   *)(&buf[0x28]) );
	printf("Prefetchable Limit      = 0x%08x \n",          *(unsigned int   *)(&buf[0x2c]) );
	printf("IO Base HI              = 0x%04x \n",          *(unsigned short *)(&buf[0x30]) );
	printf("IO Limit HI             = 0x%04x \n",          *(unsigned short *)(&buf[0x32]) );
	printf("Expansion LOM Base      = 0x%08x \n",          *(unsigned int   *)(&buf[0x38]) );
	printf("Bridge Ctl              = 0x%04x \n",          *(unsigned short *)(&buf[0x3e]) );

	printf("\n\n");
	return 0;
}

int end_pci_config_space_dump(void)
{
	int i;
	char *buf;
	unsigned int data;
	unsigned int end_pci_config_space[CONFIG_SPACE_SIZE/4] = {0};

	for(i=0; i < CONFIG_SPACE_SIZE/4; i++){
		config_read(0, i*4, &data);
		end_pci_config_space[i] = data;
	}

	buf = (char *)&end_pci_config_space[0x00];

	printf("\n");
	printf("Vender ID           = 0x%04x \n",         *(unsigned short *)(&buf[0x00]) );
	printf("Device ID           = 0x%04x \n",         *(unsigned short *)(&buf[0x02]) );
	printf("CMD                 = 0x%04x \n",         *(unsigned short *)(&buf[0x04]) );
	printf("STATUS              = 0x%04x \n",         *(unsigned short *)(&buf[0x06]) );
	printf("Rev ID              = 0x%02x \n",         *(unsigned char  *)(&buf[0x08]) );
	printf("Class Code          = 0x%02x%02x%02x \n", *(unsigned char  *)(&buf[0x0b] ),
			*(unsigned char  *)(&buf[0x0a] ),
			*(unsigned char  *)(&buf[0x09] ));
	printf("Cache Line Size     = 0x%02x \n",         *(unsigned char  *)(&buf[0x0c]) );
	printf("Mst Latency Timer   = 0x%02x \n",         *(unsigned char  *)(&buf[0x0d]) );
	printf("Header Type         = 0x%02x \n",         *(unsigned char  *)(&buf[0x0e]) );
	printf("BIST                = 0x%02x \n",         *(unsigned char  *)(&buf[0x0f]) );
	printf("BAR0                = 0x%08x \n",         *(unsigned int   *)(&buf[0x10]) );
	printf("BAR1                = 0x%08x \n",         *(unsigned int   *)(&buf[0x14]) );
	printf("BAR2                = 0x%08x \n",         *(unsigned int   *)(&buf[0x18]) );
	printf("BAR3                = 0x%08x \n",         *(unsigned int   *)(&buf[0x1c]) );
	printf("BAR4                = 0x%08x \n",         *(unsigned int   *)(&buf[0x20]) );
	printf("BAR5                = 0x%08x \n",         *(unsigned int   *)(&buf[0x24]) );
	printf("Cardbus CIS Pointer = 0x%08x \n",         *(unsigned int   *)(&buf[0x28]) );
	printf("SubSys Vender ID    = 0x%04x \n",         *(unsigned short *)(&buf[0x2c]) );
	printf("SubSys  ID          = 0x%04x \n",         *(unsigned short *)(&buf[0x2e]) );
	printf("Expansion LOM Base  = 0x%08x \n",         *(unsigned int   *)(&buf[0x30]) );
	printf("Capability List     = 0x%02x \n",         *(unsigned char  *)(&buf[0x34]) );
	printf("Int Line            = 0x%02x \n",         *(unsigned char  *)(&buf[0x3c]) );
	printf("Int Pin             = 0x%02x \n",         *(unsigned char  *)(&buf[0x3d]) );
	printf("Min Gnt             = 0x%02x \n",         *(unsigned char  *)(&buf[0x3e]) );
	printf("Max Latency         = 0x%02x \n",         *(unsigned char  *)(&buf[0x3f]) );

	printf("\n");

	return 0;
}

int config_read(unsigned int target, unsigned int offset, unsigned int *data)
{

	struct magnes_ioctl_cmd magnes_cmd_struct;
	int ret = 0;

	ssize_t fd = open ("/dev/magnes0", O_RDWR);
	if (fd == -1) {
		printf ("Couldn't open the device.\n");
		return 0;
	}

	magnes_cmd_struct.cfg_num     = target;
	magnes_cmd_struct.cfg_offset  = offset;

	ret = ioctl(fd, MAGNES_CMD_CONFIG_READ, &magnes_cmd_struct);
	if(ret < 0){
		perror("MAGNES_CMD_CONFIG_READ");
	}

	*data = magnes_cmd_struct.buf;

	close(fd);

	return ret;
}

int config_write(unsigned int target, unsigned int offset, unsigned int data)
{

	struct magnes_ioctl_cmd magnes_cmd_struct;
	int ret = 0;

	ssize_t fd = open ("/dev/magnes0", O_RDWR);
	if (fd == -1) {
		printf ("Couldn't open the device.\n");
		return 0;
	}

	magnes_cmd_struct.cfg_num     = target;
	magnes_cmd_struct.cfg_offset  = offset;
	magnes_cmd_struct.buf         = data;

	ret = ioctl(fd, MAGNES_CMD_CONFIG_WRITE, &magnes_cmd_struct);
	if(ret < 0){
		perror("MAGNES_CMD_CONFIG_WRITE");
	}

	close(fd);

	return ret;
}

int barX_read(unsigned int bar_num, unsigned int offset, unsigned int *data)
{

	struct magnes_ioctl_cmd magnes_cmd_struct;
	int ret = 0;

	ssize_t fd = open ("/dev/magnes0", O_RDWR);
	if (fd == -1) {
		printf ("Couldn't open the device.\n");
		return 0;
	}

	magnes_cmd_struct.bar_num     = bar_num;
	magnes_cmd_struct.bar_offset  = offset;

	ret = ioctl(fd, MAGNES_CMD_BAR_READ, &magnes_cmd_struct);
	if(ret < 0){
		perror("MAGNES_CMD_BAR_READ");
	}

	*data = magnes_cmd_struct.buf;

	close(fd);

	return ret;
}

int barX_write(unsigned int bar_num, unsigned int offset, unsigned int data)
{
	struct magnes_ioctl_cmd magnes_cmd_struct;
	int ret = 0;

	ssize_t fd = open ("/dev/magnes0", O_RDWR);
	if (fd == -1) {
		printf ("Couldn't open the device.\n");
		return 0;
	}

	magnes_cmd_struct.bar_num     = bar_num;
	magnes_cmd_struct.bar_offset  = offset;
	magnes_cmd_struct.buf         = data;

	ret = ioctl(fd, MAGNES_CMD_BAR_WRITE, &magnes_cmd_struct);
	if(ret < 0){
		perror("MAGNES_CMD_BAR_WRITE");
	}

	close(fd);

	return ret;
}

unsigned int *map_bar(unsigned int bar_num, unsigned int offset, unsigned int size)
{
	int ret;
	unsigned int *buf;
	struct magnes_ioctl_cmd map_cmd;

	ssize_t fd = open ("/dev/magnes0", O_RDWR);
	if (fd == -1) {
		printf ("Couldn't open the device.\n");
		return 0;
	}

	map_cmd.bar_num    = bar_num;
	map_cmd.bar_offset = offset;

	ret = ioctl(fd, MAGNES_CMD_BAR_MAP, &map_cmd);
	if(ret < 0){
		perror("MAGNES_CMD_BAR_MAP");
	}

	buf = mmap(NULL, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, map_cmd.bar_offset);

	close(fd);

	return buf;
}
