/* 
 * Copyright (c) 2017, Intel Corporation.
 * Intel, the Intel logo, Intel, MegaCore, NIOS II, Quartus and TalkBack 
 * words and logos are trademarks of Intel Corporation or its subsidiaries 
 * in the U.S. and/or other countries. Other marks and brands may be 
 * claimed as the property of others.   See Trademarks on intel.com for 
 * full list of Intel trademarks or the Trademarks & Brands Names Database 
 * (if Intel) or See www.Intel.com/legal (if Altera).
 * All rights reserved
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * BSD 3-Clause license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 *      - Neither Intel nor the names of its contributors may be 
 *        used to endorse or promote products derived from this 
 *        software without specific prior written permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/************************************************************************************
 * Copyright (C) 2018 ALTIMA Company MACNICA, Inc. All Rights Reserved.\n
 *   This software is licensed "AS IS". 
 *   Please perform use of this software by a user's own responsibility and expense.
 *   It cannot guarantee in the maker side about the damage which occurred by the ab-
 *   ility not to use or use this software, and all damage that occurred secondarily.
 ***********************************************************************************/

struct magnes_rw_cmd {
	unsigned int bar_num;
	unsigned int offset;
	unsigned int data;
};

struct magnes_ioctl_cmd {
    int          cmd;
    int          cfg_num;
    int          cfg_offset;
    int          bar_num;
    int          bar_offset;
    unsigned int buf;
};

#if 1
#define MAGNES_CONFIG_READ  (0x01)
#define MAGNES_CONFIG_WRITE (0x02)
#define MAGNES_BAR_READ     (0x03)
#define MAGNES_BAR_WRITE    (0x04)
#define MAGNES_BAR_MAP      (0x05)

#endif

#define MAGNES_IOCTL_TYPE 'M'

#define MAGNES_CMD_CONFIG_READ   _IOWR(MAGNES_IOCTL_TYPE, MAGNES_CONFIG_READ,  struct magnes_ioctl_cmd)
#define MAGNES_CMD_CONFIG_WRITE  _IOWR(MAGNES_IOCTL_TYPE, MAGNES_CONFIG_WRITE, struct magnes_ioctl_cmd)
#define MAGNES_CMD_BAR_READ      _IOWR(MAGNES_IOCTL_TYPE, MAGNES_BAR_READ,     struct magnes_ioctl_cmd)
#define MAGNES_CMD_BAR_WRITE     _IOWR(MAGNES_IOCTL_TYPE, MAGNES_BAR_WRITE,    struct magnes_ioctl_cmd)
#define MAGNES_CMD_BAR_MAP       _IOWR(MAGNES_IOCTL_TYPE, MAGNES_BAR_MAP,      struct magnes_ioctl_cmd)



